// ---------------------------------------------------------------------

#include "image_functions.inc"


#macro set_theta_blend_mode(theta_blend_mode)
    // undef if exist
    #undef f_rise_for_theta_blend
    #undef f_fall_for_theta_blend
    

    #switch(theta_blend_mode)
        #case(0) // linear blend
            #declare f_rise_for_theta_blend =
            f_linear_blend_rise;
        #break;
        #case(1) // cos - sin blend
            #declare f_rise_for_theta_blend =
            f_cos_blend_rise;
        #break;
        #case(2) //
            #local par0 = 2.20;
            #local par1 = 2*pi;
            #local val0 = -4.1415;
            #local val1 = 5;
            #local par_l = par1 - par0;
        
            #declare f_rise_for_theta_blend =
            function(th, th0, th1) {
            (
                  3* cos( par_l*(th - th0)/(th1 - th0) + par0)
                + 2* cos(2*( par_l*(th - th0)/(th1 - th0) + par0))
                -    cos(3*( par_l*(th - th0)/(th1 - th0) + par0))
                +    cos(4*( par_l*(th - th0)/(th1 - th0) + par0))
                - val0
            )/(val1 - val0)
            }
        
        #break
        #case(3)
        
        
        #break
    #end

    #declare f_fall_for_theta_blend =
    function(th, th0, th1) {
    1 - f_rise_for_theta_blend(th, th0, th1)
    }
#end

set_theta_blend_mode(1) // cos - sin blend





/***************************************
*
* @ log y( year, theta, h )ܤpattern internal
* զXJ}C
*
*  f_year_and_h_spread_array vTA
* outputO@sb year (invert age) VWL noise function theta զX
*
* 
* f_output(year, theta, h)
*
*
****************************************/

#macro generate_thin_circled_pattern_func_by_blend_theta_chop(
year_bump_size, theta_pos_array,
f_year_and_h_spread_array, // f_year_and_h_spread_array ƶqnM theta_pos_array @
f_theta_mask, // single function input theta
f_noise_apply_vs_year, year_and_h_mix_to_year_and_theta_mode, // mode=0 ۭ,  mode=1 ĥ min
theta_more_thin, more_thin_factor,
seed_m
)
    
    
    #local theta_node_amount = dimension_size(theta_pos_array, 1);
        
    
    
    #local f_thin_pattern_mix_detail_array = array[theta_node_amount];
    #local f_thin_pattern_year_and_theta_part_array = array[theta_node_amount];

    
    
    
// Step 1. prepare f_thin_pattern_year_and_theta_part_array
    
    #if(theta_more_thin)
    // ----- theta pattern Fΰ}CA]bump  -----
        #local avg_theta_interval = 2*pi/theta_node_amount;
        
        #for(i, 0, theta_node_amount - 1)
            #local a = rand(seed_m);
            #local b = 0.8 + 0.4*rand(seed_m);
            #local c = rand(seed_m);
            #if(i = 0)
                #local f_thin_pattern_year_and_theta_part_array[0] =
                function(var_t, theta) {
                select(
                    theta - pi, // ݬObWb٬OUb
                    f_noise_apply_vs_year(var_t/(year_bump_size*b), theta*more_thin_factor/avg_theta_interval, 2.5*theta_node_amount*a),
                    f_noise_apply_vs_year(var_t/(year_bump_size*b), (theta - 2*pi)*more_thin_factor/avg_theta_interval, 2.5*theta_node_amount*a)
                )
                }
                
            #elseif(i = theta_node_amount - 1)
                #local f_thin_pattern_year_and_theta_part_array[i] =
                function(var_t, theta) {
                select(
                    theta - pi, // ݬObWb٬OUb
                    f_noise_apply_vs_year(var_t/(year_bump_size*b), (theta + 2*pi)*more_thin_factor/avg_theta_interval, 2.5*theta_node_amount*a),
                    f_noise_apply_vs_year(var_t/(year_bump_size*b), theta*more_thin_factor/avg_theta_interval, 2.5*theta_node_amount*a)
                )
                }
            #else
                #local f_thin_pattern_year_and_theta_part_array[i] =
                function(var_t, theta) {
                f_noise_apply_vs_year(var_t/(year_bump_size*b), theta*more_thin_factor/avg_theta_interval, 2.5*theta_node_amount*a)
                }
            #end
        #end
        
    #else
    // ----- theta pattern ΰ}C -----
        #for(i, 0, theta_node_amount - 1)
            #local a = rand(seed_m);
            #local b = 0.8 + 0.4*rand(seed_m);
            #local c = rand(seed_m);
            
            #local f_thin_pattern_year_and_theta_part_array[i] =
            function(var_t, theta) {
            f_noise_apply_vs_year(var_t/(year_bump_size*b), 0, 2.5*theta_node_amount*a)
            }
        #end
    #end     
            
            
// Step 2. mix f_thin_pattern_year_and_theta_part_array
//         and f_year_and_h_spread_array
//         to f_thin_pattern_mix_detail_array
        
    #for(i, 0, theta_node_amount - 1)
        #switch(year_and_h_mix_to_year_and_theta_mode)
            #case(0)
                #local f_thin_pattern_mix_detail_array[i] =
                function(var_t, theta, h) {
                f_thin_pattern_year_and_theta_part_array[i](var_t, theta)
                *f_year_and_h_spread_array[i](var_t, h)
                }
            #break;
            #case(1)
                #local f_thin_pattern_mix_detail_array[i] =
                function(var_t, theta, h) {
                f_imitate_min_r1_5(
                f_thin_pattern_year_and_theta_part_array[i](var_t, theta),
                f_year_and_h_spread_array[i](var_t, h)
                )
                }
            #break;
            #case(2) // uf_year_and_h_spread_array
                #local f_thin_pattern_mix_detail_array[i] =
                function(var_t, theta, h) {
                
          
                f_year_and_h_spread_array[i](var_t, h)
                }
            #break;
        #end
            
    #end    
    
    
    
// Step 3. combine f_thin_pattern_mix_detail_array
//         (using theta_pos_array),
//         then multiply a f_theta_mask() 
        
    #local output_f =
    function(var_t, theta, h) {
    select(
        theta - theta_pos_array[0],
        f_thin_pattern_mix_detail_array[theta_node_amount - 1](var_t, theta, h)*f_fall_for_theta_blend(theta, theta_pos_array[theta_node_amount - 1] - 2*pi, theta_pos_array[0]) + f_thin_pattern_mix_detail_array[0](var_t, theta, h)*f_rise_for_theta_blend(theta, theta_pos_array[theta_node_amount - 1] - 2*pi, theta_pos_array[0]),
        #for(i, 1, theta_node_amount - 1)
            select(
                theta - theta_pos_array[i],
                f_thin_pattern_mix_detail_array[i-1](var_t, theta, h)*f_fall_for_theta_blend(theta, theta_pos_array[i-1], theta_pos_array[i]) + f_thin_pattern_mix_detail_array[i](var_t, theta, h)*f_rise_for_theta_blend(theta, theta_pos_array[i-1], theta_pos_array[i]),
        #end
                f_thin_pattern_mix_detail_array[theta_node_amount - 1](var_t, theta, h)*f_fall_for_theta_blend(theta, theta_pos_array[theta_node_amount - 1], theta_pos_array[0] + 2*pi) + f_thin_pattern_mix_detail_array[0](var_t, theta, h)*f_rise_for_theta_blend(theta, theta_pos_array[theta_node_amount - 1], theta_pos_array[0] + 2*pi)
        
        #for(i, 0, theta_node_amount - 1)
            )
        #end
    
    *f_theta_mask(theta)
    
    }
        
    
    
    output_f


#end









#macro generate_wood_heart_thin_pattern_func()

#end
