




#macro generate_pinstripe_ring_pattern(f_early_late_ratio)



    // pinstripes
    #local f_pinstripe_coverage_evaluate_in_oneyear =
    function(t_at_year, early_late_ratio) {
    select(
        t_at_year - (early_late_ratio - late_early_vary_t),
        1,
        select(
            t_at_year - early_late_ratio,
            f_cos_blend_fall(t_at_year, early_late_ratio - late_early_vary_t, early_late_ratio),
            select(
                t_at_year - (1 - early_late_vary_t),
                0,
                select(
                    t_at_year - 1,
                    f_cos_blend_rise(t_at_year, 1 - early_late_vary_t, 1),
                    1
                )
            )
        )
    )
    }
    
    
    
    #local f_pinstripe_coverage_evaluate =
    function(year, early_late_ratio) {
    f_pinstripe_coverage_evaluate_in_oneyear(year - int(year), early_late_ratio)
    }
    
    
    #local f_result =
    function (year) {
    f_pinstripe_coverage_evaluate(year, f_early_late_ratio(year))
    }
    
    
    
    
    f_result


#end






#macro generate_linear_band_ring_pattern(f_early_late_ratio)

    // linear wood band
    #local f_woodband_coverage_evaluate_in_oneyear =
    function(t_at_year, early_late_ratio) {
    select(
        early_late_ratio - 0.5,
        // where 0 < early_late_ratio < 0.5
        select(
            t_at_year - 2*early_late_ratio,
            -t_at_year/(early_late_ratio*2) + 1,
            0
        ),
        // where 0.5 < early_late_ratio < 1
        select(
            t_at_year - 2*early_late_ratio + 1,
            1,
            -t_at_year/(1 - early_late_ratio)/2 + 1/(1 - early_late_ratio)/2
        )
    )
    }
    
    
    
    #local f_woodband_coverage_evaluate =
    function(var_t, early_late_ratio) {
    f_woodband_coverage_evaluate_in_oneyear(var_t - int(var_t), early_late_ratio)
    }
    
    
    #local f_result =
    function (year) {
    f_woodband_coverage_evaluate(year, f_early_late_ratio(year))
    }
    
    
    
    f_result


#end