#ifndef(Image_Functions_Inc_Temp)
#declare Image_Functions_Inc_Temp = version;
#version 3.7;





#macro convertImageToFunction(file_name)
    #local pig_input =
    pigment {
        image_map
            {
                png file_name
                gamma 1.0
                once  interpolate 2
            }
    }
    
    #local f_color_convert =
    function {
    pigment {pig_input}
    }
    
    
    #local f_convert =
    function(var1, var2) {
    f_color_convert(var1, var2, 0).gray
    }
    
    f_convert

#end





#declare f_linear_step_0to1 =
function(var) {
    select(
        var,
        0,
        select(
            var - 1,
            var,
            1
        )
    )
}







#macro createImitateMinFunc(file_name)
    #local f_min_convert =
    convertImageToFunction(file_name);
    

    #local f_imitate_min_x0to1 =
    function(var1, var2) {
        select(
            var2,
            0,
            select(
                var2 - 1,
                f_min_convert(var1, var2),
                var1
            )
        )
    }

    #local f_imitate_min =
    function(var1, var2) {
        select(
            var1,
            0,
            select(
                var1 - 1,
                f_imitate_min_x0to1(var1, var2),
                f_linear_step_0to1(var2)
            )
        )
    }

    f_imitate_min
#end


#macro createImitateMaxFunc(file_name)
    #local f_max_convert =
    convertImageToFunction(file_name);

    #local f_imitate_max_x0to1 =
    function(var1, var2) {
        select(
            var2,
            var1,
            select(
                var2 - 1,
                f_max_convert(var1, var2),
                1
            )
        )
    }
    
    #local f_imitate_max =
    function(var1, var2) {
        select(
            var1,
            f_linear_step_0to1(var2),
            select(
                var1 - 1,
                f_imitate_max_x0to1(var1, var2),
                1
            )
        )
    }

    f_imitate_max
#end




#declare f_imitate_min_r1 = createImitateMinFunc("f_min_imitate1.0.png");
#declare f_imitate_min_r1_5 = createImitateMinFunc("f_min_imitate1.5.png");
#declare f_imitate_min_r2 = createImitateMinFunc("f_min_imitate2.0.png");
#declare f_imitate_min_r10 = createImitateMinFunc("f_min_imitate10.0.png");


#declare f_imitate_max_r1_5 = createImitateMaxFunc("f_max_imitate1.5.png");
#declare f_imitate_max_r2 = createImitateMaxFunc("f_max_imitate2.0.png");
#declare f_imitate_max_r10 = createImitateMaxFunc("f_max_imitate10.0.png");





#version Image_Functions_Inc_Temp;
#end//image_functions.inc
