#include "image_functions.inc"




// streak 

// -------------mid sapwood ------------------------
#local c_wood_ring_line = rgb<0.291, 0.106, 0.00615>;

#local c_wood_ring = rgb<0.384, 0.154, 0.0118>;
#local c_wood_ring_dark = rgb<0.28, 0.18, 0.041>;

#local c_base = rgb<0.36, 0.157, 0.024>;
#local c_base_dark = rgb<0.325, 0.122, 0.009>;
#local c_base3 = rgb<0.383, 0.551, 0.013>*0.5;







#declare cmap_woodring_on_mid_sap =
color_map {
    [0 c_wood_ring]
    [0.35 c_wood_ring]
    [0.7 c_wood_ring_dark]
}


#declare cmap_base_fiber1_on_mid_sap =
color_map {
    [0 c_base]
    [0.4 c_base]
    [0.65 c_base_dark]
}


#declare cmap_base_fiber2_on_mid_sap =
color_map {
    [0  c_wood_ring]
    [0.5 c_wood_ring]
    [0.6 c_base3]
}





#declare p_woodring_line_on_mid_sap =
pigment {
    color c_wood_ring_line
}


#declare p_fiber_on_ring_on_mid_sap =
pigment {
    function {
        f_thin_fiber(x,y,z, year_function_with_turbulence(x, y, z))
    }
    color_map {
    cmap_woodring_on_mid_sap
    }
}



#declare p_fiber_on_base_on_mid_sapA =
pigment {
    function {
        f_thin_fiber(x,y,z, year_function_with_turbulence(x, y, z))
    }
    color_map {
    cmap_base_fiber1_on_mid_sap
    }
}
#declare p_fiber_on_base_on_mid_sapB =
pigment {
    function {
        f_thin_fiber(x,y,z, year_function_with_turbulence(x, y, z))
    }
    color_map {
    cmap_base_fiber2_on_mid_sap    
    }
}

#declare p_pattern_on_base_on_mid_sap =
pigment {
    function {
        f_large_color_block(x,y,z, year_function(x, y, z))
    }
    pigment_map {
        [0 p_fiber_on_base_on_mid_sapA]
        [1.0 p_fiber_on_base_on_mid_sapB]
    }
}





#declare p_on_mid_sap_without_darkline =
pigment {
    function {
        f_wood_band_pattern(year_function_with_turbulence(x, y, z))
         //(0.7 + 0.3* f_large_color_block(x,y,z, time_function(x, y, z)) )
         /*
        f_imitate_max_r2(
        0.65*f_ring_pattern(time_function(x, y, z)),
         ring_trans_f(x,y,z)
         ) */
    }
    pigment_map{
        [0  p_pattern_on_base_on_mid_sap]
        [0.08  p_pattern_on_base_on_mid_sap]
        [0.8 p_fiber_on_ring_on_mid_sap]
    }
}



#declare p_on_mid_sap =
pigment {
    function {
    f_pinstripes_pattern(year_function_with_turbulence(x, y, z))
    *(0.9 + 0.1* f_large_color_block(x,y,z, year_function(x, y, z)) )
    }
    pigment_map {
        [0.93 p_on_mid_sap_without_darkline]
        [1 p_woodring_line_on_mid_sap]
    }
}



// --------- inner sapwood -------------------

#local c_wood_ring = rgb<0.291, 0.106, 0.00615>;
#local c_wood_ring_dark = rgb<0.16, 0.04, 0.0003>;
#local c_wood_ring_burnt = rgb<0.101, 0.0161, 0.00002>;

#local c_base = rgb<0.335, 0.137, 0.0183>;
#local c_base_dark = rgb<0.256, 0.0883, 0.0052>;
//#local c_base3 = rgb<0.383, 0.151, 0.013>;

#declare cmap_woodring_on_inner_sap =
color_map {
    [0 c_wood_ring]
    [0.45 c_wood_ring]
    [0.6 c_wood_ring_dark]
}


#declare cmap_base_fiber1_on_inner_sap =
color_map {
    [0 c_base]
    [0.4 c_base_dark]
    [0.65 c_base_dark]
}


#declare cmap_base_fiber2_on_inner_sap =
color_map {
    [0  c_base]
    [0.5 c_base]
    [0.6 c_base_dark]
}








#declare p_fiber_on_ring_on_inner_sap =
pigment {
    function {
        f_thin_fiber(x,y,z, year_function_with_turbulence(x, y, z))
    }
    color_map {
    cmap_woodring_on_inner_sap
    }
}



#declare p_fiber_on_base_on_inner_sapA =
pigment {
    function {
        f_thin_fiber(x,y,z, year_function_with_turbulence(x, y, z))
    }
    color_map {
    cmap_base_fiber1_on_inner_sap
    }
}
#declare p_fiber_on_base_on_inner_sapB =
pigment {
    function {
        f_thin_fiber(x,y,z, year_function_with_turbulence(x, y, z))
    }
    color_map {
    cmap_base_fiber2_on_inner_sap    
    }
}

#declare p_pattern_on_base_on_inner_sap =
pigment {
    function {
        f_large_color_block(x,y,z, year_function(x, y, z))
    }
    pigment_map {
        [0 p_fiber_on_base_on_inner_sapA]
        [1.0 p_fiber_on_base_on_inner_sapB]
    }
}








#declare p_on_inner_sap =
pigment {
    function {
        f_pinstripes_pattern(year_function_with_turbulence(x, y, z))
         //(0.7 + 0.3* f_large_color_block(x,y,z, time_function(x, y, z)) )
         /*
        f_imitate_max_r2(
        0.65*f_ring_pattern(time_function(x, y, z)),
         ring_trans_f(x,y,z)
         ) */
    }
    pigment_map{
        [0  p_pattern_on_base_on_inner_sap]
        [0.08  p_pattern_on_base_on_inner_sap]
        [0.8 p_fiber_on_ring_on_inner_sap]
    }
}


// ------ heartwood ------------------------
#local c_wood_ring = rgb<0.2428, 0.08, 0.0078>;
#local c_wood_ring_dark = rgb<0.0992, 0.0428, 0.0023>;
#local c_wood_ring_burnt = rgb<0.079, 0.020, 0.010>;

#local c_heart_bright = rgb<0.3289, 0.12, 0.0354>;
#local c_heart_bright_bump = rgb<0.2071, 0.0874, 0.01565>;
#local c_heart_bright_bump2 = rgb<0.221, 0.0765, 0.0215>;







#declare p_fiber_on_ring_on_heartwood =
pigment {
    function {
        f_thin_fiber(x,y,z, year_function_with_turbulence(x, y, z))
    }
    color_map {
        [0 c_wood_ring]
        [0.44 c_wood_ring]
        [0.65 c_wood_ring_dark]
    }
}



#declare p_base_pattern_on_heartA =
pigment {
    function {
        f_thin_fiber(x,y,z, year_function_with_turbulence(x, y, z))
    }
    color_map {
        [0 c_heart_bright]
        [0.4 c_heart_bright]
        [0.65 c_heart_bright_bump2]
    }
}

#declare p_base_pattern_on_heartB =
pigment {
    function {
        f_thin_fiber(x,y,z, year_function_with_turbulence(x, y, z))
    }
    color_map {
        [0  c_heart_bright]
        [0.5 c_heart_bright_bump]
        [0.6 c_heart_bright_bump2]
    }
}


#declare p_base_pattern_on_heart =
pigment {
    function {
        f_large_color_block(x,y,z, year_function_with_turbulence(x, y, z))
    }
    pigment_map {
        [0 p_base_pattern_on_heartA]
        [1.0 p_base_pattern_on_heartB]
    }
}


#declare p_on_heart =
pigment {
    function {
        f_wood_band_pattern(year_function_with_turbulence(x, y, z))*
         (0.7 + 0.3* f_large_color_block(x,y,z, year_function_with_turbulence(x, y, z)) )
         /*
        f_imitate_max_r2(
        0.65*f_ring_pattern(time_function(x, y, z)),
         ring_trans_f(x,y,z)
         ) */
    }
    pigment_map{
        [0  p_base_pattern_on_heart]
        [0.28  p_base_pattern_on_heart]
        [0.8 p_fiber_on_ring_on_heartwood]
    }
}






// ----------------------------- j ---------------------------------------------

#include "generate_pattern_steps.inc"




// ɳt (year)
#declare bound_pith_heart_0 = 0.0;
#declare bound_pith_heart_1 = 5.0;

#declare bound_heart_inner_sap_0 = 10.0;
#declare bound_heart_inner_sap_1 = 12.0;

#declare bound_inner_mid_sap_0 = 18.0;
#declare bound_inner_mid_sap_1 = 22.3;

#declare bound_mid_outer_sap_0 = 31.0;
#declare bound_mid_outer_sap_1 = 37.0;






#declare bump_amplitude = 0.45;

#declare noise_space_size = 0.43;


#declare f_step1 = generate_pattern_step(bound_pith_heart_0, bound_pith_heart_1, bump_amplitude, noise_space_size);
#declare f_step2 = generate_pattern_step(bound_heart_inner_sap_0, bound_heart_inner_sap_1, bump_amplitude, noise_space_size);
#declare f_step3 = generate_pattern_step(bound_inner_mid_sap_0, bound_inner_mid_sap_1, bump_amplitude, noise_space_size);
#declare f_step4 = generate_pattern_step(bound_mid_outer_sap_0, bound_mid_outer_sap_1, bump_amplitude, noise_space_size);



#declare f_value_selector =
function (value1, value2, value3, value4) {
select(
    value1 - 0.99999,
    value1*0.1,
    select(
        value2 - 0.99999,
        value2*0.1 + 0.1,
        select(
            value3 - 0.99999,
            value3*0.1 + 0.2,
            value4*0.1 + 0.3
        )
    )
    
)
}




#declare p_pith_wood =
pigment {
    color rgb<0, 0, 0>
}


#declare p_heart_wood =
pigment {
    p_on_heart
}



#declare p_inner_sap_wood =
pigment {
    p_on_inner_sap
}


#declare p_middle_sap_wood =
pigment {
    p_on_mid_sap
}


#declare p_outer_sap_wood =
pigment {
    p_on_mid_sap
}









// j
#declare f_main_distinguish =
function(x, y, z, year_func_value) {
f_value_selector(f_step1(x, y, year_func_value), f_step2(x, y, year_func_value), f_step3(x, y, year_func_value), f_step4(x, y, year_func_value))

}









#declare diffuse_pigment =
pigment{
    function {
        f_main_distinguish(x, y, z, year_function(x, y, z))
    }
    pigment_map{
        [0.0 p_pith_wood]
        [0.1 p_heart_wood]
        [0.2 p_inner_sap_wood]
        [0.3 p_middle_sap_wood]
        [0.4 p_outer_sap_wood]
        [1.0 p_outer_sap_wood]
    }


    
}







/*
#declare diffuse_pigment =
pigment{
    function {
        f_main_distinguish(x, y, z, year_function(x, y, z))
    }
    pigment_map{
        [0.0 p_pith_wood]
        [0.0001 p_pith_wood]
        
        [0.0999 p_heart_wood]
        [0.1001 p_heart_wood]
        
        [0.1999 p_inner_sap_wood]
        [0.2001 p_inner_sap_wood]
        
        [0.2999 p_middle_sap_wood]
        [0.3001 p_middle_sap_wood]
        
        [0.3999 p_outer_sap_wood]
        [1.0 p_outer_sap_wood]
    }


    
}
*/
